<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (version 1.7.0_80) on Wed Sep 20 14:52:11 UTC 2017 -->
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>DisambiguationRuleChain (Gradle API 4.2)</title>
<meta name="date" content="2017-09-20">
<link rel="stylesheet" type="text/css" href="../../../../javadoc.css" title="Style">
</head>
<body>
<script type="text/javascript"><!--
    if (location.href.indexOf('is-external=true') == -1) {
        parent.document.title="DisambiguationRuleChain (Gradle API 4.2)";
    }
//-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar_top">
<!--   -->
</a><a href="#skip-navbar_top" title="Skip navigation links"></a><a name="navbar_top_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-all.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../org/gradle/api/attributes/CompatibilityRuleChain.html" title="interface in org.gradle.api.attributes"><span class="strong">Prev Class</span></a></li>
<li><a href="../../../../org/gradle/api/attributes/HasAttributes.html" title="interface in org.gradle.api.attributes"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../index.html?org/gradle/api/attributes/DisambiguationRuleChain.html" target="_top">Frames</a></li>
<li><a href="DisambiguationRuleChain.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">org.gradle.api.attributes</div>
<h2 title="Interface DisambiguationRuleChain" class="title">Interface DisambiguationRuleChain&lt;T&gt;</h2>
</div>
<div class="contentContainer">
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl><dt><span class="strong">Type Parameters:</span></dt><dd><code>T</code> - the concrete type of the attribute</dd></dl>
<hr>
<br>
<pre><a href="../../../../org/gradle/api/Incubating.html" title="annotation in org.gradle.api">@Incubating</a>
public interface <span class="strong">DisambiguationRuleChain&lt;T&gt;</span></pre>
<div class="block"><p>A chain of disambiguation rules. By default the chain is empty and will not do any disambiguation.</p>

 <p>For a given set of rules, the execution is done <i>in order</i>, and interrupts as soon as a rule
 selected at least one candidate (through <a href="../../../../org/gradle/api/attributes/MultipleCandidatesDetails.html#closestMatch(T)"><code>MultipleCandidatesDetails.closestMatch(Object)</code></a>).
 </p>

 <p>If the end of the rule chain is reached and that no rule selected a candidate then the candidate list is returned
 unmodified, meaning we still have an ambiguous match.</p></div>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method_summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span>Methods</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/attributes/DisambiguationRuleChain.html#add(java.lang.Class)">add</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Class.html?is-external=true" title="class or interface in java.lang">Class</a>&lt;? extends <a href="../../../../org/gradle/api/attributes/AttributeDisambiguationRule.html" title="interface in org.gradle.api.attributes">AttributeDisambiguationRule</a>&lt;<a href="../../../../org/gradle/api/attributes/DisambiguationRuleChain.html" title="type parameter in DisambiguationRuleChain">T</a>&gt;&gt;&nbsp;rule)</code>
<div class="block">Adds an arbitrary disambiguation rule to the chain.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/attributes/DisambiguationRuleChain.html#add(java.lang.Class,%20org.gradle.api.Action)">add</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Class.html?is-external=true" title="class or interface in java.lang">Class</a>&lt;? extends <a href="../../../../org/gradle/api/attributes/AttributeDisambiguationRule.html" title="interface in org.gradle.api.attributes">AttributeDisambiguationRule</a>&lt;<a href="../../../../org/gradle/api/attributes/DisambiguationRuleChain.html" title="type parameter in DisambiguationRuleChain">T</a>&gt;&gt;&nbsp;rule,
   <a href="../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../org/gradle/api/ActionConfiguration.html" title="interface in org.gradle.api">ActionConfiguration</a>&gt;&nbsp;configureAction)</code>
<div class="block">Adds an arbitrary disambiguation rule to the chain, possibly configuring the rule as well.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/attributes/DisambiguationRuleChain.html#pickFirst(java.util.Comparator)">pickFirst</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/util/Comparator.html?is-external=true" title="class or interface in java.util">Comparator</a>&lt;? super <a href="../../../../org/gradle/api/attributes/DisambiguationRuleChain.html" title="type parameter in DisambiguationRuleChain">T</a>&gt;&nbsp;comparator)</code>
<div class="block">Adds an ordered disambiguation rule.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/attributes/DisambiguationRuleChain.html#pickLast(java.util.Comparator)">pickLast</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/util/Comparator.html?is-external=true" title="class or interface in java.util">Comparator</a>&lt;? super <a href="../../../../org/gradle/api/attributes/DisambiguationRuleChain.html" title="type parameter in DisambiguationRuleChain">T</a>&gt;&nbsp;comparator)</code>
<div class="block">Adds an ordered disambiguation rule.</div>
</td>
</tr>
</table>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method_detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="add(java.lang.Class)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>add</h4>
<pre>void&nbsp;add(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Class.html?is-external=true" title="class or interface in java.lang">Class</a>&lt;? extends <a href="../../../../org/gradle/api/attributes/AttributeDisambiguationRule.html" title="interface in org.gradle.api.attributes">AttributeDisambiguationRule</a>&lt;<a href="../../../../org/gradle/api/attributes/DisambiguationRuleChain.html" title="type parameter in DisambiguationRuleChain">T</a>&gt;&gt;&nbsp;rule)</pre>
<div class="block"><p>Adds an arbitrary disambiguation rule to the chain.</p>
 <p>A disambiguation rule can select the best match from a list of candidates.</p>

 <p>A rule <i>can</i> express an preference by calling the @{link <a href="../../../../org/gradle/api/attributes/MultipleCandidatesDetails.html#closestMatch(T)"><code>MultipleCandidatesDetails.closestMatch(Object)</code></a>
 method to tell that a candidate is the best one.</p>

 <p>It is not mandatory for a rule to choose, and it is not an error to select multiple candidates.</p></div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>rule</code> - the rule to add</dd><dt><span class="strong">Since:</span></dt>
  <dd>4.0</dd></dl>
</li>
</ul>
<a name="add(java.lang.Class, org.gradle.api.Action)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>add</h4>
<pre>void&nbsp;add(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Class.html?is-external=true" title="class or interface in java.lang">Class</a>&lt;? extends <a href="../../../../org/gradle/api/attributes/AttributeDisambiguationRule.html" title="interface in org.gradle.api.attributes">AttributeDisambiguationRule</a>&lt;<a href="../../../../org/gradle/api/attributes/DisambiguationRuleChain.html" title="type parameter in DisambiguationRuleChain">T</a>&gt;&gt;&nbsp;rule,
       <a href="../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../org/gradle/api/ActionConfiguration.html" title="interface in org.gradle.api">ActionConfiguration</a>&gt;&nbsp;configureAction)</pre>
<div class="block"><p>Adds an arbitrary disambiguation rule to the chain, possibly configuring the rule as well.</p></div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>rule</code> - the rule to add</dd><dd><code>configureAction</code> - the action to use to configure the rule</dd><dt><span class="strong">Since:</span></dt>
  <dd>4.0</dd></dl>
</li>
</ul>
<a name="pickFirst(java.util.Comparator)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>pickFirst</h4>
<pre>void&nbsp;pickFirst(<a href="https://docs.oracle.com/javase/7/docs/api/java/util/Comparator.html?is-external=true" title="class or interface in java.util">Comparator</a>&lt;? super <a href="../../../../org/gradle/api/attributes/DisambiguationRuleChain.html" title="type parameter in DisambiguationRuleChain">T</a>&gt;&nbsp;comparator)</pre>
<div class="block">Adds an ordered disambiguation rule. Values will be compared using the
 provided comparator, and the rule will automatically select the first
 value (if multiple candidates have the same attribute value, there will
 still be an ambiguity).</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>comparator</code> - the comparator to use</dd></dl>
</li>
</ul>
<a name="pickLast(java.util.Comparator)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>pickLast</h4>
<pre>void&nbsp;pickLast(<a href="https://docs.oracle.com/javase/7/docs/api/java/util/Comparator.html?is-external=true" title="class or interface in java.util">Comparator</a>&lt;? super <a href="../../../../org/gradle/api/attributes/DisambiguationRuleChain.html" title="type parameter in DisambiguationRuleChain">T</a>&gt;&nbsp;comparator)</pre>
<div class="block">Adds an ordered disambiguation rule. Values will be compared using the
 provided comparator, and the rule will automatically select the last
 value (if multiple candidates have the same attribute value, there will
 still be an ambiguity).</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>comparator</code> - the comparator to use</dd></dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar_bottom">
<!--   -->
</a><a href="#skip-navbar_bottom" title="Skip navigation links"></a><a name="navbar_bottom_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-all.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../org/gradle/api/attributes/CompatibilityRuleChain.html" title="interface in org.gradle.api.attributes"><span class="strong">Prev Class</span></a></li>
<li><a href="../../../../org/gradle/api/attributes/HasAttributes.html" title="interface in org.gradle.api.attributes"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../index.html?org/gradle/api/attributes/DisambiguationRuleChain.html" target="_top">Frames</a></li>
<li><a href="DisambiguationRuleChain.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
